<?php

/**
 * certificado_retefuente actions.
 *
 * @package    nomina
 * @subpackage certificado_retefuente
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class certificado_retefuenteActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'NO_CERTI_RETEFUENTE',
        'NO_DATOS_FUNCIONARIO_V',
        'NO_CONCEP_NOMINA',
        'NO_PERIODO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'id_tipo_doc' => 'NO_CERTI_RETEFUENTE',
            'num_doc' => 'NO_CERTI_RETEFUENTE'
        ),
        'NO_CONCEP_NOMINA' =>
        array(
            'id_concep_nomina' => 'NO_CERTI_RETEFUENTE'
        ),
        'NO_PERIODO_V' =>
        array(
            'id_periodo' => 'NO_CERTI_RETEFUENTE'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_CERTI_RETEFUENTE' =>
        array(
            'id_certi_retefuente' => 'id_certi_retefuente',
            'id_tipo_doc' => 'id_tipo_doc',
            'num_doc' => 'num_doc',
            'id_concep_nomina' => 'id_concep_nomina',
            'id_periodo' => 'id_periodo',
            'meses' => 'meses',
            'valor_descuento' => 'valor_descuento',
            'observaciones' => 'observaciones',
            'porcentaje' => 'porcentaje',
            'estado' => 'estado',
            'fecha_anu' => 'fecha_anu',
            'motivo_anu' => 'motivo_anu',
            'valor_total' => 'valor_total',
            'fecha_validez_ini' => 'fecha_validez_ini',
            'fecha_validez_fin' => 'fecha_validez_fin',
            'adjunto' => 'adjunto'
        ),
        'NO_DATOS_FUNCIONARIO_V' =>
        array(
            'nombre_completo' => 'nombre_completo'
        ),
        'NO_CONCEP_NOMINA' =>
        array(
            'codigo' => 'codigo_concepto',
            'descripcion' => 'descripcion_concepto',
            'codigo,||, - ,||,descripcion' => 'completo_concepto'
        ),
        'NO_PERIODO_V' =>
        array(
            'id_anhos' => 'id_anhos',
            'id_meses' => 'id_meses',
            'id_tipo_periodo' => 'id_tipo_periodo',
            'periodo' => 'periodo',
            'max_ded_noley' => 'max_ded_noley'
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'NO_CERTI_RETEFUENTE' => array(
            'id_certi_retefuente,a' => array('!=' => array(-1)),
            'id_certi_retefuente,b' => array('=' => array('id_certi_retefuente')),
            'id_tipo_doc' => array('=' => array('id_tipo_doc')),
            'num_doc' => array('=' => array('num_doc')),
            'id_concep_nomina' => array('=' => array('id_concep_nomina')),
            'id_periodo' => array('=' => array('id_periodo_filtro')),
            'estado' => array('=' => array('estado_certi')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'NO_CONCEP_NOMINA' => array(
            'aplica_certif' => array('=' => array('aplica_certif')),
            'estado' => array('=' => array('estado'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    protected $fields_orderBy = array(
        'num_doc', 'id_anhos', 'id_meses', 'codigo_concepto'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_certi_retefuente'; //identificador de la tabla
    protected $id_names = array('id_certi_retefuente'); //llave primaria
    protected $field_names = array('id_periodo', 'id_tipo_doc', 'num_doc', 'id_concep_nomina',
        'meses', 'valor_descuento', 'observaciones', 'porcentaje', 'estado', 'fecha_anu', 'motivo_anu',
        'valor_total', 'fecha_validez_ini', 'fecha_validez_fin', 'adjunto'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'NO_CERTI_RETEFUENTE'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_certi_retefuente'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;
        $id_tipo_doc = $request['id_tipo_doc'];
        $num_doc = $request['num_doc'];
        $id_periodo = $request['id_periodo'];
        $id_concep_nomina = $request['id_concep_nomina'];

        /*
         *  Validar la operación, ya sea por SQL
         */

        $sql = <<<EOD
select * 
from no_certi_retefuente
where
id_tipo_doc = $id_tipo_doc
and num_doc = '$num_doc'
and id_periodo = $id_periodo
and id_concep_nomina = $id_concep_nomina   
and estado = 1  
EOD;
        $records = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */

        if (count($records) > 0) {
            $errors['mensaje'] = "No puede registrar el mismo concepto activo mas de una vez. Favor verificar";
            $errors['servicio'] = "certificado_retefuente";
        }

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        $id_tipo_doc = $request['id_tipo_doc'];
        $num_doc = $request['num_doc'];
        $id_periodo = $request['id_periodo'];
        $id_concep_nomina = $request['id_concep_nomina'];
        $id_certi_retefuente = $request['id_certi_retefuente'];

        /*
         *  Validar la operación, ya sea por SQL
         */

        $sql = <<<EOD
select * 
from no_certi_retefuente
where
id_tipo_doc = $id_tipo_doc
and num_doc = '$num_doc'
and id_periodo = $id_periodo
and id_concep_nomina = $id_concep_nomina   
and id_certi_retefuente != $id_certi_retefuente   
and estado = 1 
EOD;
        $records = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */

        if (count($records) > 0) {
            $errors['mensaje'] = "No puede registrar el mismo concepto activo mas de una vez. Favor verificar";
            $errors['servicio'] = "certificado_retefuente";
        }

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL - 20150417
         */

        $sql = <<<EOD
SELECT * FROM no_periodo where ACTIVO = 1 
EOD;

        $results = CN_TABLE::executeSQL($sql);

        $id_periodo = $results[0]['id_periodo'];

        $id_certi_retefuente = $request['id_certi_retefuente'];

        $sql = <<<EOD
select * 
from no_certi_retefuente
where
id_certi_retefuente = $id_certi_retefuente    
EOD;
        $results = CN_TABLE::executeSQL($sql);

        $id_periodo_nov = $results[0]['id_periodo'];

        /*
         *  Generar errores en $errors
         */
        if ($id_periodo != $id_periodo_nov) {
            $errors['mensaje'] = "El certificado no corresponde al periodo en el cual esta ejecutando la nómina actual. Favor Verificar antes de Eliminar.";
            $errors['servicio'] = "certificado_retefuente";
        }

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            //Para anexar registro en no_concepto_func
            if (isset($request['registro_func'])) {
                if (isset($request['meses'])) {
                    if ($request['meses'] > 0) {
                        if (isset($request['valor_total'])) {
                            $request['valor_descuento'] = $request['valor_total'] / $request['meses'];
                        }
                    }
                }
                if (!isset($request['valor_descuento'])) {
                    $request['valor_descuento'] = 1;
                }
                if (!isset($request['valor_total'])) {
                    $request['valor_total'] = 1;
                }
            }
        }

        //accion update
        if ($Action == "UPDATE") {

            //Para anexar registro en no_concepto_func
            if (isset($request['registro_func'])) {
                if (isset($request['meses'])) {
                    if ($request['meses'] > 0) {
                        if (isset($request['valor_total'])) {
                            $request['valor_descuento'] = $request['valor_total'] / $request['meses'];
                        }
                    }
                }
                if (!isset($request['valor_descuento'])) {
                    $request['valor_descuento'] = 1;
                }
                if (!isset($request['valor_total'])) {
                    $request['valor_total'] = 1;
                }
            }
        }

        //accion remove
        if ($Action == "REMOVE") {

            $id_certi_retefuente = $request['id_certi_retefuente'];

            $sql = <<<EOD
SELECT * FROM NO_CERTI_RETEFUENTE WHERE id_certi_retefuente = $id_certi_retefuente
EOD;

            $results = CN_TABLE::executeSQL($sql);

            if (count($results) > 0) {
                $request['id_tipo_doc'] = $results[0]['id_tipo_doc'];
                $request['num_doc'] = $results[0]['num_doc'];
                $request['id_concep_nomina'] = $results[0]['id_concep_nomina'];
                $request['id_periodo'] = $results[0]['id_periodo'];
            }
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            /*
             * Manejo de errores
             */
            try {

                //Para anexar registro en no_concepto_func
                if (isset($request['registro_func'])) {

                    $id_tipo_doc = $list_data_post[0]['id_tipo_doc'];
                    $num_doc = $list_data_post[0]['num_doc'];
                    $id_concep_nomina = $list_data_post[0]['id_concep_nomina'];
                    $valor = $list_data_post[0]['valor_descuento'];
                    $porcentaje = $list_data_post[0]['porcentaje'];
                    $fecha_desde = CN_TABLE::fechaSistema();
                    //Se toman fecha de registro y se actualizan segun estas - 20240502::LAVILA
                    $fecha_desde = $list_data_post[0]['fecha_validez_ini'];
                    $fecha_hasta = $list_data_post[0]['fecha_validez_fin'];

                    $sql = <<<EOD
SELECT * FROM no_concepto_func  
    where id_tipo_doc = $id_tipo_doc and num_doc = $num_doc
      and id_concep_nomina = $id_concep_nomina and actual = 1
EOD;

                    $results = CN_TABLE::executeSQL($sql);

                    if (count($results) > 0) {

                        $sql = <<<EOD
update no_concepto_func set estado = 0 , actual = 0, fecha_hasta = to_date('$fecha_desde','yyyy-mm-dd')-1 
    where id_tipo_doc = $id_tipo_doc and num_doc = $num_doc
      and id_concep_nomina = $id_concep_nomina and actual = 1
EOD;
                        //execute sql
                        $this->conn->execute($sql);

                        $sql = <<<EOD
insert into no_concepto_func (id_concep_func,id_tipo_doc,num_doc,id_concep_nomina,
    valor,porcentaje,estado,actual,fecha_desde,fecha_hasta) 
    values (null, $id_tipo_doc, '$num_doc',
        $id_concep_nomina, $valor, $porcentaje,1,1,
            to_date('$fecha_desde','yyyy-mm-dd'),to_date('$fecha_hasta','yyyy-mm-dd')) 
EOD;
                        //execute sql
                        $this->conn->execute($sql);
                    } else {

                        $sql = <<<EOD
insert into no_concepto_func (id_concep_func,id_tipo_doc,num_doc,id_concep_nomina,
    valor,porcentaje,estado,actual,fecha_desde,fecha_hasta) 
    values (null, $id_tipo_doc, '$num_doc',
        $id_concep_nomina, $valor, $porcentaje,1,1,
            to_date('$fecha_desde','yyyy-mm-dd'),to_date('$fecha_hasta','yyyy-mm-dd')) 
EOD;
                        //execute sql
                        $this->conn->execute($sql);
                    }
                }


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            /*
             * Manejo de errores
             */
            try {

                //Para anexar registro en no_concepto_func
                if (isset($request['registro_func'])) {

                    $id_tipo_doc = $list_data_post[0]['id_tipo_doc'];
                    $num_doc = $list_data_post[0]['num_doc'];
                    $id_concep_nomina = $list_data_post[0]['id_concep_nomina'];
                    $valor = $list_data_post[0]['valor_descuento'];
                    $porcentaje = $list_data_post[0]['porcentaje'];
                    $fecha_desde = CN_TABLE::fechaSistema();
                    //Se toman fecha de registro y se actualizan segun estas - 20240502::LAVILA
                    $fecha_desde = $request['fecha_validez_ini'];
                    $fecha_hasta = $request['fecha_validez_fin'];

                    $sql = <<<EOD
update no_concepto_func set valor = $valor , porcentaje = $porcentaje,
    fecha_desde = to_date('$fecha_desde','yyyy-mm-dd'),
    fecha_hasta = to_date('$fecha_hasta','yyyy-mm-dd')  
    where id_tipo_doc = $id_tipo_doc and num_doc = $num_doc
      and id_concep_nomina = $id_concep_nomina and actual = 1
EOD;
                    //execute sql
                    $this->conn->execute($sql);
                }


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion remove
        if ($Action == "REMOVE") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            /*
             * Manejo de errores
             */
            try {



                $id_tipo_doc = $request['id_tipo_doc'];
                $num_doc = $request['num_doc'];
                $id_concep_nomina = $request['id_concep_nomina'];
                $id_periodo = $request['id_periodo'];
                $fecha_desde = CN_TABLE::fechaSistema();

                /*
                 * Verificar que el concepto aplique certificado - 20140530 
                 */
                $sql = <<<EOD
select * from no_concep_nomina
where aplica_certif = 1
and id_concep_nomina = $id_concep_nomina 
EOD;

                $results = CN_TABLE::executeSQL($sql);

                //Para anexar registro en no_concepto_func
//                if ($request['id_concep_nomina'] == 545) {
                if (count($results) > 0) {

                    $sql = <<<EOD
update no_concepto_func set estado = 0 , actual = 0, fecha_hasta = to_date('$fecha_desde','yyyy-mm-dd')  
    where id_tipo_doc = $id_tipo_doc and num_doc = $num_doc
      and id_concep_nomina = $id_concep_nomina and actual = 1
EOD;
                    //execute sql
                    $this->conn->execute($sql);

                    $sql = <<<EOD
delete from no_concepto_periodo 
where  id_tipo_doc = $id_tipo_doc and num_doc = $num_doc
      and id_concep_nomina = $id_concep_nomina and periodo = $id_periodo 
EOD;
                    //execute sql
                    $this->conn->execute($sql);
                }


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        return $request;
    }

}
